/*******************************************************************************
 * Copyright (c) 2005 BEA Systems, Inc. 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 *******************************************************************************/

package org.example.processor.internal.webservice;

import java.util.Collection;
import java.util.Map;
import java.util.Set;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import com.sun.mirror.apt.AnnotationProcessor;
import com.sun.mirror.apt.AnnotationProcessorEnvironment;
import com.sun.mirror.apt.Messager;
import com.sun.mirror.declaration.AnnotationMirror;
import com.sun.mirror.declaration.AnnotationTypeDeclaration;
import com.sun.mirror.declaration.AnnotationTypeElementDeclaration;
import com.sun.mirror.declaration.AnnotationValue;
import com.sun.mirror.declaration.ClassDeclaration;
import com.sun.mirror.declaration.Declaration;
import com.sun.mirror.declaration.FieldDeclaration;
import com.sun.mirror.declaration.MethodDeclaration;
import com.sun.mirror.declaration.ParameterDeclaration;
import com.sun.mirror.type.ClassType;
import com.sun.mirror.type.PrimitiveType;
import com.sun.mirror.type.TypeMirror;
import com.sun.mirror.util.DeclarationFilter;

 

public class Processor implements AnnotationProcessor {
// TODO: assignment 1: find all declarations decorated with @WebMethod

	public static final String annotationNameWebService = "javax.jws.WebService";
	public static final String annotationNameWebMethod = "javax.jws.WebMethod";
	public static final String elementNameOperationName = "operationName";

	private final Set<AnnotationTypeDeclaration> _atds;
	private final AnnotationProcessorEnvironment _env;
	private final Pattern alphaMatch = Pattern.compile("[a-zA-Z]");

	public Processor(Set<AnnotationTypeDeclaration> atds,
			AnnotationProcessorEnvironment env) {
		_atds = atds;
		_env = env;
		if (APFactory.TRACING) {
			StringBuilder sb = new StringBuilder();
			sb.append("Processor ");
			sb.append(this.getClass().getName());
			sb.append(" was constructed for annotations:");
			for (AnnotationTypeDeclaration atd : _atds) {
				sb.append("\n");
				sb.append(atd.getQualifiedName());
			}
			APFactory.trace(sb.toString());
		}
	}

	public void process() {
		
		// *** Here we do element value error checking ***
		Messager messager = _env.getMessager();
		
		// TODO: obtain the declaration of the annotation we want to process (annotationNameWebMethod)
		AnnotationTypeDeclaration annoDecl = null;	// hint: look at methods on _env
		
		// Don't trust anything you get from the mirror APIs; this runs as the user is typing
		if (annoDecl == null) {
			return;							
		}
		
		// TODO: get the annotated declarations
		Collection<Declaration> annotatedDecls = null;	// hint: look at methods on _env
		if (annotatedDecls == null) {
			return;
		}
		
		// iterate over the declarations
		for (Declaration decl : annotatedDecls) {
			// TODO: For each declaration, get the annotation mirrors
			
			
				// TODO: find each @WebMethod annotation (hint: compare to string annotationNameWebMethod defined above)
			
					// TODO: for each @WebMethod annotation, call processWebMethod()
		}
	}

	// process a declaration annotated with @WebMethod
	private void processWebMethod(Messager messager, AnnotationMirror mirror, Declaration decl) {
		APFactory.trace("processWebMethod called on " + decl.getSimpleName());
	}
		
		


}
