/*******************************************************************************
 * Copyright (c) 2007 BEA Systems, Inc.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *******************************************************************************/

package org.example.processor.internal;

import java.util.Set;

import com.sun.mirror.apt.AnnotationProcessor;
import com.sun.mirror.apt.AnnotationProcessorEnvironment;
import com.sun.mirror.apt.Filer;
import com.sun.mirror.apt.Messager;
import com.sun.mirror.declaration.AnnotationTypeDeclaration;

public class Processor implements AnnotationProcessor {
	
	private final Set<AnnotationTypeDeclaration> _atds;
	private final AnnotationProcessorEnvironment _env;
	private final Messager _messager;
	private final Filer _filer;

	public Processor(Set<AnnotationTypeDeclaration> atds,
			AnnotationProcessorEnvironment env) {
		_atds = atds;
		_env = env;
		_messager = _env.getMessager();
		_filer = _env.getFiler();
		if (APFactory.TRACING) {
			StringBuilder sb = new StringBuilder();
			sb.append("Processor ");
			sb.append(this.getClass().getName());
			sb.append(" was constructed for annotations:");
			for (AnnotationTypeDeclaration atd : _atds) {
				sb.append("\n");
				sb.append(atd.getQualifiedName());
			}
			APFactory.trace(sb.toString());
		}
	}

	public void process() {
		// TODO put your annotation processing logic here
	}

}
